<template>
  <div id="aod">

    <h2>{{ currentCrumb.name }}</h2>

    <Breadcrumb />

    <div class="sideflow">
      <p class="my-3 help">
        {{ store.state.selectedMethodo === 'methodo2' ? currentCrumb.descMethodo2 : currentCrumb.desc }}
      </p>

      <Form />
    </div>

    <div class="mt-4 float-end" v-if="currentCrumb.id !== 5">
      <button class="btn btn-light" :disabled="!validatedStep" @click="nextStep">Suivant</button>
    </div>

  </div>
</template>

<script lang="ts">
import { useStore } from '@/store'
import {computed, defineComponent, watch} from "vue";
import Breadcrumb from './Breadcrumb.vue';
import Form from './Form.vue';
import {crumbs} from "@/utils/_crumbs";
import {Station} from "@/api";
import {fromLonLat} from "ol/proj";

export default defineComponent ({
  name: "SidebarAOD",
  components: { Breadcrumb, Form },
  setup: () => {

    const store = useStore();

    watch(() => store.state.selectedStationId, (current) => {
      if (current !== null) {
        const selectedStation = store.state.stations?.filter((station) => station.id === current)
        changeMapView(selectedStation[0]);
      }
    })

    const changeMapView = (s: Station | null) => {
      const view = store.state.map.getView();
      if (s) {
        view?.setZoom(12);
        view?.setCenter(fromLonLat(s.geometry.coordinates, 'EPSG:3857'));
      }

      if (s === null) {
        view?.setZoom(9);
        view?.setCenter([485016.44, 6550857.95])
        if (store.state.content === 'chart') {
          store.commit('switchContent', 'map');
        }
      }
    }

    const nextStep = () => {
      if (store.state.currentCrumb.id === 3) {
        store.commit('setDrawState', {
          isDrawing: false,
          type: ''
        });
      }

      if (store.state.currentCrumb.id === 4) {
        store.dispatch('computeResults');
      }

      store.commit('showResults', store.state.currentCrumb.id === 4);

      if (store.state.currentCrumb.id === 5) {
        return;
      }

      if (store.state.validatedStep) {
        store.commit('setMessage', '');
        store.commit('setActivatedCrumbs', (store.state.currentCrumb.id + 1));
        store.commit('setCurrentCrumb', crumbs[store.state.currentCrumb.id])
      }
    }

    return {
      store,
      currentCrumb: computed(() => store.state.currentCrumb),
      message: computed(() => store.state.message),
      nextStep,
      validatedStep: computed(() => store.state.validatedStep),
    }
  }
})
</script>

<style lang="scss" scoped>
</style>
